//#include "stdafx.h"
#include "hidapi.h"
#include "fe_interface.h"
#include <stdio.h>
#include <wchar.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>
#include "eeprom.h"
#include "tcp_shell.h"

#define RF_GAIN_ZERO    -10
#define MAX_STR 255
	int GainIndex[7]={0,4,2,6,1,5,3};
	double GainTable[7]={1.00, 1.14, 1.33, 1.60, 2.00, 2.67, 4};
        int FE_Gain = 0;
	volatile int hid_status=0;
        wchar_t wstr[MAX_STR+1];
        hid_device *fe_handle=NULL;
        int HID_COMMAND_SIZE = 7;
        int global_device_PID = HID_DEVICE_SDR_NET_PID;
        unsigned char hid_tcp_packet[32]={0};
        volatile int hid_tcp_network_flag = 0;
        volatile int hid_command_send_state = 0;
	int HID_Device_Enumerate()
	{
		struct hid_device_info *devs = 0;
		devs = hid_enumerate(HID_DEVICE_VID, HID_DEVICE_PID);
		if(devs != 0)
		{
			hid_free_enumeration(devs);
			return 1;
		}
		else
		{
                    devs = hid_enumerate(HID_DEVICE_ATEECS_VID, HID_DEVICE_SDR_NET_PID);
                    if(devs != 0)
                    {
                            hid_free_enumeration(devs);
                            return 1;
                    }
                    else
                    {
                        devs = hid_enumerate(HID_DEVICE_ATEECS_VID, HID_DEVICE_ATEECS_PID);
                        if(devs != 0)
                        {
                                hid_free_enumeration(devs);
                                return 1;
                        }
                        else
                        {
                            return 0;
                        }
                    }
		}

	}

	int HID_Device_Reconnect( char * msg)
	{
		int res=0;
                if(hid_status)
		{
                  if(fe_handle)  hid_close(fe_handle);
		}
		res = HID_Device_Init(msg);
		return res;
	}

	int HID_Device_Init( char * msg)
	{
		int res;
                fe_handle = hid_open(HID_DEVICE_VID, HID_DEVICE_PID, NULL);
                if (!fe_handle)
                {
                     fe_handle = hid_open(HID_DEVICE_ATEECS_VID, HID_DEVICE_SDR_NET_PID, NULL);
                     if (!fe_handle)
                     {
                         fe_handle = hid_open(HID_DEVICE_ATEECS_VID, HID_DEVICE_ATEECS_PID, NULL);
                         if (!fe_handle)
                         {
                             strcpy(msg ,"Unable to open device!");
                              hid_status=0;
                              return 0;
                         }
                         else
                         {
                            global_device_PID = HID_DEVICE_ATEECS_PID;
                            HID_COMMAND_SIZE = 5;
                         }
                     }
                     else
                     {
                         global_device_PID = HID_DEVICE_SDR_NET_PID;
                         HID_COMMAND_SIZE = 7;
                     }
                 }
                else
                {
                    global_device_PID = HID_DEVICE_ATEECS_PID;
                    HID_COMMAND_SIZE = 5;
                }
                if(fe_handle)
                {
                    hid_status=1;
                    wstr[0] = 0x0000;
                    hid_set_nonblocking(fe_handle, 1);
                    res = hid_get_product_string(fe_handle, wstr, MAX_STR);
                    if (res < 0)
                    {
                        strcpy(msg,"Unable to read product string");
                    }
                    else
                    {
                        wcstombs(msg, wstr, wcslen(wstr));
                    }
                   // Set the hid_read() function to be non-blocking.
                        res = hid_set_nonblocking(fe_handle, 1);
        //                  if(res < 0) return res;

                }
                return 1;
	}

	int HID_Read_Data( char *buf)
	{
                int res=0;
                buf[0] = 0;
                if(hid_tcp_network_flag == 1)
                {
                    if(((hid_tcp_packet[1] >> 5) == TCP_HID_PACKET) && (hid_tcp_packet[0] != 0))
                    {
                        for(int i=0; i < HID_COMMAND_SIZE; i++)
                        {
                            buf[i] = hid_tcp_packet[i+2];
                        }
                        hid_tcp_packet[0] = 0;
                        return HID_COMMAND_SIZE;
                    }
                    else return 0;
                }
                else if(hid_status)
                {
//                        res = hid_set_nonblocking(fe_handle, 1);
                        // Try to read from the device. There shoud be no
                        // data here, but execution should not block.
                        res = hid_read(fe_handle, (unsigned char *)buf, HID_COMMAND_SIZE);
                        if(res > 0) hid_command_send_state = 0;
                        return res;
                }
                return 0;
          }

        int HID_Write_Data(unsigned char *report)
        {
            int  res=0;
            unsigned char buffer[16]={0};
            if(hid_tcp_network_flag == 1)
            {
                buffer[0] = HID_COMMAND_SIZE + 2;
                buffer[1] = TCP_HID_PACKET << 5;
                for(int i=0; i < HID_COMMAND_SIZE; i++)
                {
                    buffer[i+2] = report[i];
                }
                tcp_send_hid_command((char *)buffer, HID_COMMAND_SIZE+2);
                return 1;
            }
            else if(hid_status)
            {
                res = hid_write(fe_handle, (const unsigned char *)report, HID_COMMAND_SIZE);
                if(res > 0) hid_command_send_state = 1;
                else hid_command_send_state = 0;
                return res;
            }
            return 0;
        }

        void hid_change_tcp_network_flag(int state)
        {
            hid_tcp_network_flag = state;
        }

        int hid_save_recieved_tcp_packet(char *data, int size)
        {
            int i;
            for(i=0; i < size; i++)
            {
                hid_tcp_packet[i] = data[i];
            }
            return 0;
        }

	int HID_Set_Frequency(unsigned long frequency)
	{
                int i;
                unsigned char report[HID_COMMAND_MAX_SIZE]={0};
		report[0] = HID_FREQUENCY_REPORT;
		for(i=0; i < 4;  i++)
		{
			report[i+1]= (frequency >> (i*8)) & 0xFF;
		}
                for(i=5; i < HID_COMMAND_MAX_SIZE;  i++) report[i]=0;
                return HID_Write_Data((unsigned char *)report);
	}

        int HID_Get_Frequency(int channel)
	{
                char report[HID_COMMAND_MAX_SIZE]={0};
                report[0] = HID_GENERIC_REPORT;
                report[1]=  HID_GENERIC_GET_FREQ_COMMAND & 0xFF;
                report[2]= channel;
                for(int i=3; i < HID_COMMAND_MAX_SIZE;  i++) report[i]=0;
                return HID_Write_Data((unsigned char *)report);
	}

	unsigned long HID_Read_Frequency(const unsigned char *buf)
	{
		unsigned long frequency =0;
		unsigned long long_tmp;
		int i;
		for(i =0; i<4; i++)
		{
			long_tmp = buf[i+1] & 0xFF;
			frequency += long_tmp << (i*8);
		}
		return frequency;
	}

        unsigned long HID_Get_Generic_Report(unsigned char *generic_command, const unsigned char *buf)
	{
		unsigned long data =0;
		unsigned long long_tmp;
		int i;
                *generic_command = buf[1];
                for(i =0; i<4; i++)
		{
                        long_tmp = buf[i+2] & 0xFF;
			data += long_tmp << (i*8);
		}
		return data;
	}

	int HID_ChangeFE_Gain(int index)
	{
                char report[HID_COMMAND_MAX_SIZE]={0};
                report[0] = HID_GENERIC_REPORT;
                report[1]=  HID_GENERIC_GAIN_COMMAND & 0xFF;
                report[2]= index+1;
                for(int i=3; i < HID_COMMAND_MAX_SIZE;  i++) report[i]=0;
                return HID_Write_Data((unsigned char *)report);
	}

	int HID_ChangeFE_DAC(int dac_value)
	{
                char report[HID_COMMAND_MAX_SIZE]={0};
			report[0] = HID_GENERIC_REPORT;
			report[1]=  HID_GENERIC_DAC_COMMAND & 0xFF;
			report[2]= dac_value & 0xFF;
                        for(int i=3; i < HID_COMMAND_MAX_SIZE;  i++) report[i]=0;
                        return HID_Write_Data((unsigned char *)report);
	}

        int HID_Change_VCO_voltage(int vco_value)
        {
                short tmp_vco = (2048 + vco_value) & 0xFFF;
                char report[HID_COMMAND_MAX_SIZE]={0};
                        report[0] = HID_GENERIC_REPORT;
                        report[1]=  HID_GENERIC_SET_VCO_COMMAND & 0xFF;
                        report[2]= tmp_vco & 0xFF;
                        report[3]= (tmp_vco >> 8) & 0xFF;
                        for(int i=4; i < HID_COMMAND_MAX_SIZE;  i++) report[i]=0;
                        return HID_Write_Data((unsigned char *)report);
        }

        int HID_Change_BPF_Tune(unsigned short bpf_value)
        {
                char report[HID_COMMAND_MAX_SIZE]={0};
                        report[0] = HID_GENERIC_REPORT;
                        report[1]=  HID_GENERIC_SET_BPF_COMMAND & 0xFF;
                        report[2]= bpf_value & 0xFF;
                        report[3]= (bpf_value >> 8) & 0xFF;
                        for(int i=4; i < HID_COMMAND_MAX_SIZE;  i++) report[i]=0;
                        return HID_Write_Data((unsigned char *)report);
        }

        int HID_Set_Multichannel_Mode(int mode)
        {
                char report[HID_COMMAND_MAX_SIZE]={0};
                        report[0] = HID_GENERIC_REPORT;
                        report[1]=  HID_GENERIC_SET_MULTICHANNEL_COMMAND & 0xFF;
                        report[2]= mode & 0xFF;
                        for(int i=3; i < HID_COMMAND_MAX_SIZE;  i++) report[i]=0;
                        return HID_Write_Data((unsigned char *)report);
        }

        int HID_Save_Default_VCO_voltage(int vco_value)
        {
            int  res;
            long tmp=0;
            tmp = (vco_value + 2048) & 0x0FFF;
            res = HID_Send_EEPROM_Data(VADDRESS_VCO_VOLTAGE, tmp);
            return res;
        }

        int HID_Get_VCO_voltage()
        {
                char report[HID_COMMAND_MAX_SIZE]={0};
                report[0] = HID_GENERIC_REPORT;
                report[1]=  HID_GENERIC_GET_VCO_COMMAND & 0xFF;
                report[2]= 0;
                for(int i=3; i < HID_COMMAND_MAX_SIZE;  i++) report[i]=0;
                return HID_Write_Data((unsigned char *)report);
        }

        int HID_Save_Gain_Table(unsigned short gain_table)
        {
                char report[HID_COMMAND_MAX_SIZE]={0};
                        report[0] = HID_GENERIC_REPORT;
                        report[1]=  HID_GENERIC_SAVE_GAIN_TABLE_COMMAND & 0xFF;
                        report[2]= gain_table & 0xFF;
                        report[3]= (gain_table >> 8) & 0xFF;
                        for(int i=4; i < HID_COMMAND_MAX_SIZE;  i++) report[i]=0;
                        return HID_Write_Data((unsigned char *)report);
        }

        int HID_Get_Gain_Table()
        {
            int  res=0;
            res = HID_Send_Generic_Command_No_Param(HID_GENERIC_GET_GAIN_TABLE_COMMAND);
            return res;
        }

        int HID_Get_Sync_State()
        {
            int  res=0;
            res = HID_Send_Generic_Command_No_Param(HID_GENERIC_SYNC_WORD_COMMAND);
            return res;
        }

        int HID_Get_HW_CPLD_SN()
        {
            int  res=0;
            res = HID_Send_Generic_Command_No_Param(HID_GENERIC_HW_CPLD_SN_COMMAND);
            return res;
        }

        int HID_Check_FW_Version(int value)
        {
                char report[HID_COMMAND_MAX_SIZE]={0};
                        report[0] = HID_GENERIC_REPORT;
                        report[1]=  HID_GENERIC_VER_COMMAND & 0xFF;
                        for(int i=2; i < HID_COMMAND_MAX_SIZE;  i++) report[i]=0;
                        return HID_Write_Data((unsigned char *)report);
        }

        int HID_console_On(int value)
        {
            char report[HID_COMMAND_MAX_SIZE]={0};
            report[0] = HID_GENERIC_REPORT;
            report[1] = HID_GENERIC_HID_CONSOLE_ON & 0xFF;
            report[2] = value;
            for(int i=3; i < HID_COMMAND_MAX_SIZE;  i++) report[i]=0;
            return HID_Write_Data((unsigned char *)report);
        }

        int HID_Send_console_char(int value)
        {
            char report[HID_COMMAND_MAX_SIZE]={0};
            report[0] = HID_GENERIC_REPORT;
            report[1] = HID_GENERIC_CONSOLE_IO_COMMAND & 0xFF;
            report[2] = value;
            for(int i=3; i < HID_COMMAND_MAX_SIZE;  i++) report[i]=0;
            return HID_Write_Data((unsigned char *)report);
        }

        int HID_Init_FE()
	{
                char report[HID_COMMAND_MAX_SIZE]={0};
		report[0] = HID_GENERIC_REPORT;
		report[1]=  HID_GENERIC_INIT_FE_COMMAND & 0xFF;
		report[2]=  (~HID_GENERIC_INIT_FE_COMMAND) & 0xFF;
                for(int i=3; i < HID_COMMAND_MAX_SIZE;  i++) report[i]=0;
                return HID_Write_Data((unsigned char *)report);
	}

        int HID_Start_UDP_Stream(const unsigned long command)
        {
                char report[HID_COMMAND_MAX_SIZE]={0};
                report[0] = HID_GENERIC_REPORT;
                report[1]=  HID_GENERIC_START_UDP_STREAM_COMMAND & 0xFF;
                report[2]=  (command) & 0xFF;
                for(int i=3; i < HID_COMMAND_MAX_SIZE;  i++) report[i]=0;
                return HID_Write_Data((unsigned char *)report);
        }

        int HID_Set_Broadcast_Flag(const unsigned long command)
        {
                char report[HID_COMMAND_MAX_SIZE]={0};
                report[0] = HID_GENERIC_REPORT;
                report[1]=  HID_GENERIC_BROADCAST_COMMAND & 0xFF;
                report[2]=  (command) & 0xFF;
                for(int i=3; i < HID_COMMAND_MAX_SIZE;  i++) report[i]=0;
                return HID_Write_Data((unsigned char *)report);
        }

        int HID_Set_Multicast_Flag(const unsigned long command)
        {
                char report[HID_COMMAND_MAX_SIZE]={0};
                report[0] = HID_GENERIC_REPORT;
                report[1]=  HID_GENERIC_MULTICAST_COMMAND & 0xFF;
                report[2]=  (command) & 0xFF;
                for(int i=3; i < HID_COMMAND_MAX_SIZE;  i++) report[i]=0;
                return HID_Write_Data((unsigned char *)report);
        }

        int HID_Get_Broadcast_Flag()
        {
            int  res=0;
            res = HID_Send_Generic_Command_No_Param(HID_GENERIC_GET_BROADCAST_STATE_COMMAND);
            return res;
        }

        int HID_Send_LPF_Bypass(short command)
        {
            char report[HID_COMMAND_MAX_SIZE]={0};
            report[0] = HID_GENERIC_REPORT;
            report[1]=  HID_GENERIC_BYPASS_LPF_COMMAND & 0xFF;
            report[2]=  (command) & 0xFF;
            for(int i=3; i < HID_COMMAND_MAX_SIZE;  i++) report[i]=0;
            return HID_Write_Data((unsigned char *)report);
        }

        int HID_Get_Emulation_ID()
        {
            int  res=0;
            res = HID_Send_Generic_Command_No_Param(HID_GENERIC_GET_AFEDRI_ID_COMMAND);
            return res;
        }

        int HID_Set_ID_String(const unsigned long command)
        {
                char report[HID_COMMAND_MAX_SIZE]={0};
                report[0] = HID_GENERIC_REPORT;
                report[1]=  HID_GENERIC_SET_AFEDRI_ID_COMMAND & 0xFF;
                report[2]=  (command) & 0xFF;
                for(int i=3; i < HID_COMMAND_MAX_SIZE;  i++) report[i]=0;
                return HID_Write_Data((unsigned char *)report);
        }

        int HID_Save_Default_ID(const unsigned long command)
        {
                char report[HID_COMMAND_MAX_SIZE]={0};
                report[0] = HID_GENERIC_REPORT;
                report[1]=  HID_GENERIC_SAVE_AFEDRI_ID_COMMAND & 0xFF;
                report[2]=  (command) & 0xFF;
                for(int i=3; i < HID_COMMAND_MAX_SIZE;  i++) report[i]=0;
                return HID_Write_Data((unsigned char *)report);
        }
        int HID_Set_DHCP_Server_State(int command)
        {
                char report[HID_COMMAND_MAX_SIZE]={0};
                report[0] = HID_GENERIC_REPORT;
                report[1]=  HID_GENERIC_SET_DHCP_STATE_COMMAND & 0xFF;
                report[2]=  (command) & 0xFF;
                for(int i=3; i < HID_COMMAND_MAX_SIZE;  i++) report[i]=0;
                return HID_Write_Data((unsigned char *)report);
        }

        int HID_Get_DHCP_Server_State()
        {
            int  res=0;
            res = HID_Send_Generic_Command_No_Param(HID_GENERIC_GET_DHCP_STATE_COMMAND);
            return res;
        }

        long HID_Get_Init_Status()
	{
                char report[HID_COMMAND_MAX_SIZE]={0};
		report[0] = HID_GENERIC_REPORT;
		report[1]=  HID_GENERIC_GET_INIT_STATUS_COMMAND & 0xFF;
		report[2]=  (~HID_GENERIC_GET_INIT_STATUS_COMMAND) & 0xFF;
                for(int i=3; i < HID_COMMAND_MAX_SIZE;  i++) report[i]=0;
                return HID_Write_Data((unsigned char *)report);
	}

        int HID_Send_defaults_to_EEPROM()
        {
            char report[HID_COMMAND_MAX_SIZE]={0};
            report[0] = HID_GENERIC_REPORT;
            report[1]=  HID_GENERIC_SAVE_DEFAULT_PARAMS_COMMAND & 0xFF;
            report[2]= (~HID_GENERIC_SAVE_DEFAULT_PARAMS_COMMAND) & 0xFF;
            for(int i=3; i < HID_COMMAND_MAX_SIZE;  i++) report[i]=0;
            return HID_Write_Data((unsigned char *)report);
        }

        int HID_Firmware_Upgrade()
        {
            int  res=0;
            res = HID_Send_Generic_Command_No_Param(HID_GENERIC_IAP_COMMAND);
            return res;
        }

        int HID_SoftReset_SDR()
        {
            int  res=0;
            res = HID_Send_Generic_Command_No_Param(HID_GENERIC_SOFT_RESET_COMMAND);
            return res;
        }

        int HID_Get_EEPROM_Data(unsigned char VirtAddress)
        {
            char report[HID_COMMAND_MAX_SIZE]={0};
            report[0] = HID_GENERIC_REPORT;
            report[1]=  HID_READ_EEPROM_COMMAND & 0xFF;
            report[2]= VirtAddress;
            return HID_Write_Data((unsigned char *)report);
        }

        int HID_wait_device_answer()
        {
            int hid_timeout = 0;
            while(hid_command_send_state)
            {
                if(hid_timeout < 100000000L) hid_timeout++;
                else return -1;
            }
            return 0;
        }

        int HID_Get_Main_Clock_Frequency()
        {
            int res=0;
            res = HID_Get_EEPROM_Data(VADDRESS_MAIN_CLOCK_FREQ_LOW_HALFWORD);
            HID_wait_device_answer();
            res = HID_Get_EEPROM_Data(VADDRESS_MAIN_CLOCK_FREQ_HIGH_HALFWORD);
            return res;
        }

        int HID_Get_SDR_IP_Address()
        {
            int  res=0;
            res = HID_Send_Generic_Command_No_Param(HID_GENERIC_GET_SDR_IP_ADDRESS);
            return res;
        }

        int HID_Save_SDR_IP_Address(const unsigned long ip_address)
        {
            int  res;
            res =  HID_Send_Generic_Long_Data(HID_GENERIC_SAVE_SDR_IP_ADDRESS, ip_address);
            return res;
        }

        int HID_Get_SDR_IP_Mask()
        {
            int  res=0;
            res = HID_Send_Generic_Command_No_Param(HID_GENERIC_GET_SDR_IP_MASK);
            return res;
        }

        int HID_Save_SDR_IP_Mask(const unsigned long ip_mask)
        {
            int  res;
            res =  HID_Send_Generic_Long_Data(HID_GENERIC_SAVE_SDR_IP_MASK, ip_mask);
            return res;
        }

        int HID_Get_Gateway_IP_Address()
        {
            int  res=0;
            res = HID_Send_Generic_Command_No_Param(HID_GENERIC_GET_GATEWAY_IP_ADDRESS);
            return res;
        }

        int HID_Save_Gateway_IP_Address(const unsigned long ip_address)
        {
            int  res;
            res =  HID_Send_Generic_Long_Data(HID_GENERIC_SAVE_GATEWAY_IP_ADDRESS, ip_address);
            return res;
        }

        int HID_Get_DST_IP_Address()
        {
            int  res=0;
            res = HID_Send_Generic_Command_No_Param(HID_GENERIC_GET_DST_IP_ADDRESS);
            return res;
        }

        int HID_Save_DST_IP_Address(const unsigned long ip_address)
        {
            int  res;
            res =  HID_Send_Generic_Long_Data(HID_GENERIC_SAVE_DST_IP_ADDRESS, ip_address);
            return res;
        }

        int HID_Get_UDP_Port()
        {
            int  res=0;
            res = HID_Send_Generic_Command_No_Param(HID_GENERIC_GET_DST_PORT);
            return res;
        }

        int HID_Save_UDP_Port(const unsigned long port)
        {
            int  res;
            res =  HID_Send_Generic_Long_Data(HID_GENERIC_SAVE_DST_PORT, port);
            return res;
        }

        int HID_Send_Main_Clock_Frequency(unsigned long main_frequency)
        {
            int  res;
            unsigned long tmp=0;
            tmp = main_frequency & 0xFFFF;
            res = HID_Send_EEPROM_Data(VADDRESS_MAIN_CLOCK_FREQ_LOW_HALFWORD, tmp);
            tmp = (main_frequency >> 16) & 0xFFFF;
            HID_wait_device_answer();
            res = HID_Send_EEPROM_Data(VADDRESS_MAIN_CLOCK_FREQ_HIGH_HALFWORD, tmp);
            return res;
        }

        int HID_Send_Sample_Rate(unsigned long SampleRate)
        {
            int  res;
            unsigned long tmp=0;
            tmp = SampleRate & 0xFFFF;
            res = HID_Send_EEPROM_Data(VADDRESS_SAMPLE_RATE_LO, tmp);
//            sleep(100);
            tmp = (SampleRate >> 16) & 0xFFFF;
            HID_wait_device_answer();
            res = HID_Send_EEPROM_Data(VADDRESS_SAMPLE_RATE_HI, tmp);
            return res;
        }

        int HID_Set_New_Sample_Rate(unsigned long SampleRate)
        {
            int  res;
            res =  HID_Send_Generic_Long_Data(HID_GENERIC_SET_SAMPLE_RATE_COMMAND, SampleRate);
            return res;
        }

        int HID_Send_Diversity_Sample_Rate(unsigned long SampleRate)
        {
            int  res;
            unsigned long tmp=0;
            tmp = SampleRate & 0xFFFF;
            res = HID_Send_EEPROM_Data(VADDRESS_DIVERSITY_SAMPLE_RATE_LO, tmp);
            tmp = (SampleRate >> 16) & 0xFFFF;
            HID_wait_device_answer();
            res = HID_Send_EEPROM_Data(VADDRESS_DIVERSITY_SAMPLE_RATE_HI, tmp);
            return res;
        }

        int HID_Send_Diversity_Mode(short mode)
        {
            int  res;
            unsigned long tmp=0;
            tmp = mode & 0xFFFF;
            res = HID_Send_EEPROM_Data(VADDRESS_DIVERSITY_MODE, tmp);
            return res;
        }

        int HID_Get_Sample_Rate()
        {
            int  res=0;
            res = HID_Send_Generic_Command_No_Param(HID_GENERIC_GET_SR_COMMAND);
            return res;
        }

        int HID_Get_Diversity_Mode()
        {
            int  res=0;
            res = HID_Send_Generic_Command_No_Param(HID_GENERIC_GET_DIVERSITY_MODE);
            return res;
        }

        int HID_Get_Serial_Number()
        {
            int  res=0;
            res = HID_Send_Generic_Command_No_Param(HID_GENERIC_GET_SERIAL_NUMBER_COMMAND);
            return res;
        }

        int HID_Send_Generic_Command_No_Param(unsigned char command)
        {
            char report[HID_COMMAND_MAX_SIZE]={0};
            report[0] = HID_GENERIC_REPORT;
            report[1] = command;
            report[2] = 0;
            for(int i=3; i < HID_COMMAND_MAX_SIZE;  i++) report[i]=0;
            return HID_Write_Data((unsigned char *)report);
        }

        int HID_Send_Generic_Long_Data(unsigned char command, unsigned long eeprom_data)
        {
            char report[HID_COMMAND_MAX_SIZE]={0};
            report[0] = HID_GENERIC_REPORT;
            report[1]=  command & 0xFF;
            report[2]=  eeprom_data & 0xFF;
            report[3]= (eeprom_data >> 8)& 0xFF;
            report[4]= (eeprom_data >> 16)& 0xFF;
            report[5]= (eeprom_data >> 24)& 0xFF;
            for(int i=6; i < HID_COMMAND_MAX_SIZE;  i++) report[i]=0;
            return HID_Write_Data((unsigned char *)report);
        }

        int HID_Send_To_Flash_HalfWord(unsigned short address, unsigned short data)
        {
            char report[HID_COMMAND_MAX_SIZE]={0};
            report[0] = HID_GENERIC_REPORT;
            report[1]=  HID_GENERIC_WRITE_HWORD_TO_FLASH;
            report[2]=  address & 0xFF;
            report[3]= (address >> 8)& 0xFF;
            report[4]= data & 0xFF;
            report[5]= (data >> 8)& 0xFF;
            for(int i=6; i < HID_COMMAND_MAX_SIZE;  i++) report[i]=0;
            return HID_Write_Data((unsigned char *)report);
        }

        int HID_Send_EEPROM_Data(unsigned char VirtAddress, unsigned short eeprom_data)
        {
            char report[HID_COMMAND_MAX_SIZE]={0};
            report[0] = HID_MEMORY_READ_WRITE_REPORT;
            report[1]=  HID_WRITE_EEPROM_COMMAND & 0xFF;
            report[2]= VirtAddress;
            report[3]= eeprom_data & 0xFF;
            report[4]= (eeprom_data >> 8)& 0xFF;
            for(int i=5; i < HID_COMMAND_MAX_SIZE;  i++) report[i]=0;
            return HID_Write_Data((unsigned char *)report);
        }

double RF_Gain_Int_2_Double(int value)
{
    double val = (double) value;
    double Vmag = 0.25;//0.0488;//(Volts)
    double Vdbs =0;
    double Gbn, Gt;
    Vdbs = 1.50*val/255.0;
    Gbn = 20 * Vdbs / 0.6;//dB
    Gt = Gbn + 20 * log10(Vmag/0.5);
    return Gt;
}


int RF_Gain_Calc(int value)
{
    int rf_gain=0;
    rf_gain = RF_GAIN_ZERO + 3*(value>>3);
    return rf_gain;
}

int RF_Gain_IntDb_2_Int(int gain)
{
    double val = 0;
    double Vmag = 0.25;//0.0488;//(Volts)
    double Vdbs =0;
    double Gbn, Gt;
    int result = 0;
    Gt = (double)gain;
    Gbn = Gt - 20 * log10(Vmag/0.5);
    Vdbs = Gbn * 0.6 / 20;
    val = Vdbs * 255.0 / 1.5;
    result = val;
    return result;
}

//	int HID_Check_Device_Status()

//End of File
