//---------------------------------------------------------------------------
#define _ENABLE_QT_APP_
#ifdef _ENABLE_QT_APP_
    #include <QtGui/QApplication>
    #include <QThread>
    #include "mainwindow.h"
#endif
#include <pthread.h>
#include <stdlib.h>
#include <unistd.h>
#include <stdio.h>
//#include "process.h"
//#include "fe_interface.h"
#include "wr_plugin.h"
#define EXPORT

extern int RF_Gain_IntDb_2_Int(int gain);

//---------------------------------------------------------------------------
//#pragma argsused

void (* Callback_Winrad)(int, int, float, short *) = NULL;

int argc = 0;
char **argv = 0;
#ifdef _ENABLE_QT_APP_
    QApplication  *a=NULL;
    MainWindow    *w=NULL;
#else
    void *a=NULL;
    void *w=NULL;
#endif

    void *thread_run(void *)
    {
        if (!a) a = new QApplication(argc, argv);
        if(!w) w = new MainWindow();
        if(w)
        {
            w->setWindowIcon(QIcon(":/new/prefix1/images/app_icon1.png"));
            w->show();
        }
        if(a) a->exec();
        w = NULL;
        a = NULL;
return NULL;
    }

class SDR_app
{
    public:
    pthread_t mythread;

    void start()
    {
        if ( pthread_create( &mythread, NULL, thread_run, NULL) )
        {
          fprintf(stderr,"error creating thread.");
          abort();
        }
    }

    void wait(long timeout)
    {
        usleep(timeout);
    }

    int exit()
    {
        if(w)
        {
              w->hide();
              delete w;
        }
        a->quit();
        if ( pthread_join ( mythread, NULL ) )
        {
            fprintf(stderr, "error joining thread.");
            abort();
        }
return 0;
    }
} MyApp;

#ifndef _LINRAD_PLUGIN_
//int  /*WINAPI*/  DllEntryPoint(HINSTANCE hinst, unsigned long reason, void* lpReserved)
//{
 //   return 1;
//}
#endif
//---------------------------------------------------------------------------
extern "C"
bool EXPORT InitHW(char *name, char *model, int& type)
{
static bool first = true;
type = 4; // 4 ==> data returned via the sound card
if(first)
{
    first = false;
    Callback_Winrad = NULL;
}
strcpy(name, "AFEDRI SDR HW"); // change with the name of your HW
strcpy(model, " Mod. v1"); // change with the model of your HW
return true;
}
//---------------------------------------------------------------------------
extern "C"
bool EXPORT OpenHW(void)
{
#ifdef _ENABLE_QT_APP_
    MyApp.start();
#endif
     //.... display here the DLL panel ,if any....
    return true;
}
//---------------------------------------------------------------------------
extern "C"
int EXPORT StartHW(long LOfreq)
{
#ifdef _ENABLE_QT_APP_
    if(w) w->FE_Set_New_RX_Frequency(LOfreq);
    if(w) w->show();
#endif
    return 0; // number of complex elements returned each
}
//---------------------------------------------------------------------------
extern "C"
int EXPORT GetStatus(void)
{
    return 0; // status not supported by this specific HW,
}
//---------------------------------------------------------------------------
extern "C"
void EXPORT StopHW(void)
{
#ifdef _ENABLE_QT_APP_
    if(w) w->hide();
#endif
    return; // nothing to do with this specific HW
}
//---------------------------------------------------------------------------
extern "C"
void EXPORT CloseHW(void)
{
    //..... here you can shutdown your graphical interface, if any............
#ifdef _ENABLE_QT_APP_
          MyApp.exit();
//          MyApp.wait(200);
#endif
}
//---------------------------------------------------------------------------
extern "C"
int EXPORT SetHWLO(long freq)
{
#ifdef _ENABLE_QT_APP_
    if(w)
    {
        w->FE_Set_New_RX_Frequency(freq);
    }
#endif
//..... set here the LO frequency in the controlled hardware
return 0; // return 0 if the frequency is within the limits the HW can generate
}
//---------------------------------------------------------------------------
extern "C"
long EXPORT GetHWLO(void)
{
    long freq=0;
#ifdef _ENABLE_QT_APP_
    if(w) freq = w->rx_frequency;
#endif
    return freq;
}
//---------------------------------------------------------------------------
extern "C"
long EXPORT GetHWSR(void)
{
//. This DLL controls just an oscillator, not a digitizer
return 96000;//Hz
}
//---------------------------------------------------------------------------
extern "C"
void EXPORT IFLimitsChanged(long low, long high)
{
//Do whatever you want with the information about the new limits of the spectrum/waterfall window
return;
}
//---------------------------------------------------------------------------
extern "C"
void EXPORT TuneChanged(long freq)
{
//. Do whatever you want with the information about the new frequency tuned by the user
    if(w) w->RX_Set_Real_Frequency(freq);
   return;
}
//---------------------------------------------------------------------------
extern "C"
void EXPORT SetCallback(void (* Callback)(int, int, float, short *))
{
    Callback_Winrad = Callback;
    return; // this HW does not return audio data through the callback device
// nor it has the need to signal a new sampling rate.
}
//---------------------------------------------------------------------------
extern "C"
void EXPORT ShowGUI(void)
{
//. If the DLL has a GUI, now you have to make it visible
return;
}
//---------------------------------------------------------------------------
extern "C"
void EXPORT HideGUI(void)
{
//. If the DLL has a GUI, now you have to hide it
return;
}
//---------------------------------------------------------------------------
extern "C"
void EXPORT RawDataReady(long samprate, int *Ldata, int *Rdata, int numsamples)
{
//.. we dont know what to do with the raw audio data just passed from Winrad.
//.. We also could not implement this entry point.
return;
}
//--------------------------------------------------------------------------
//------Linrad Interface function Addition
extern "C"
void EXPORT SetRFGain(int gain)
{
   if(w)  w->Set_RF_Gain(gain);
   return;
}
//------------------------------------------------------------
extern "C"
int EXPORT GetRFGain(void)
{
    int igain=0;
    if(w)
    {
        igain = (int)w->RF_Gain;
    }
//    igain = RF_Gain_IntDb_2_Int(gain);
   return igain;
}

//---------------------------------------------------------------------------
