#include "mainwindow.h"
#include "net_commands.h"
#include "version.h"
#include "tcp_shell.h"
extern MainWindow    *w;
char block[32]={0};
volatile int TCP_command_pending = 0;
//volatile int tcp_write_pending = 0;

int tcp_send_frequency(unsigned long frequency, int channel)
{
    unsigned short control_code = CI_FREQUENCY;
    int size = 10;
//    block.resize(10);
    block[0] = size;
    block[1] = (SET_CONTROL_ITEM << 5);
    block[2] = control_code & 0xFF;
    block[3] = (control_code >> 8) & 0xFF;
    block[4] = channel;
    for(int i = 0; i < 4; i++)
    {
        block[5+i] = (frequency >> (i*8)) & 0xFF;
    }
    block[9] = 0;
    return TCP_write(block, size);
}

int tcp_send_sample_rate(unsigned long sample_rate)
{
    unsigned short control_code = CI_DDC_SAMPLE_RATE;
    int size = 9;
    block[0] = size;
    block[1] = (SET_CONTROL_ITEM << 5);
    block[2] = control_code & 0xFF;
    block[3] = (control_code >> 8) & 0xFF;
    block[4] = 0;
    for(int i = 0; i <4; i++)
    {
        block[5+i] = (sample_rate >> (i*8)) & 0xFF;
    }
    return TCP_write(block, size);
}

int tcp_set_udp_rx_state(unsigned char command)
{
    unsigned short control_code = CI_RECEIVER_STATE;
    int size = 8;
//    block.resize(8);
    block[0] = size;
    block[1] = (SET_CONTROL_ITEM << 5);
    block[2] = control_code & 0xFF;
    block[3] = (control_code >> 8) & 0xFF;
    block[4] = 0x80;
    block[5] = command;
    block[6] = 0;
    block[7] = 0;
    return TCP_write(block, size);
}

int tcp_set_rf_gain_state(char gain)
{
    unsigned short control_code = CI_RF_GAIN;
    int size = 6;
//    block.resize(6);
    block[0] =  size;
    block[1] = (SET_CONTROL_ITEM << 5);
    block[2] = control_code & 0xFF;
    block[3] = (control_code >> 8) & 0xFF;
    block[4] = 0;
    block[5] = gain;
    return TCP_write(block, size);
}

int TCP_write(char *block, int size)
{
    static char *block_to_send=NULL;
    static int size_to_send=0;
        if((size > 0))// && (size_to_send == 0))
        {
            block_to_send = (char *) malloc(size);
            if(block_to_send == 0) return 1;
            memcpy(block_to_send, block, size);
            size_to_send = size;
        }
    if(w && (TCP_command_pending == 0))
    {
        if(w->tcpSocket != NULL)
        {
#ifdef _TCP_DISCONNECTION_
            if(w->tcpSocket->state() == QAbstractSocket::UnconnectedState)
            {
                w->tcpSocket->connectToHost(w->SDR_IP_Address, w->UDP_Port);
                w->tcpSocket->waitForConnected(1000);
            }
#endif
            if(w->tcpSocket->state() == QAbstractSocket::ConnectedState)
            {
                if(block_to_send != NULL)
                {
                    w->tcpSocket->write(block_to_send, size_to_send);
                    w->tcpSocket->flush();
                    w->tcpSocket->waitForBytesWritten(1000);
                    tcp_set_pending_flag();
                    free(block_to_send);
                    block_to_send = NULL;
                    size_to_send = 0;
                }
                else return 1;
            }
            else return 1;
          }
    }
    else return 2;
    return 0;
}

int tcp_send_hid_command(char *block, int size)
{
    return TCP_write(block, size);
}

void tcp_clear_pending_flag()
{
    TCP_command_pending = 0;
}

void tcp_set_pending_flag()
{
    TCP_command_pending = 1;
}

int tcp_get_pending_flag()
{
    return TCP_command_pending;
}
//End of File

