#include <QtGui/QApplication>
#include <QThread>
#include <QMutex>
#include "mainwindow.h"
#include <windows.h>
#include <winsock2.h>
#include <ws2tcpip.h>
//#include <winbase.h>
#include <stdio.h>
#include <stdlib.h>
#include "udp_client.h"
#include "wr_plugin.h"
//#include "fe_interface.h"

//#define _FILE_OUT_ENABLE_
#define APP_PORT 50000
#define MULTICAST_ADDRESS 0xEEFF0002
#define LOCAL_IP_ADDRESS  /*0xC0A80168/*/0xC0A80001
#define BROADCAST_HEADER_SIZE 16

//DWORD WINAPI UDP_Process(LPVOID lpParameter);
//int UDP_Process();

SOCKADDR_IN remote;
SOCKET sock;
//HANDLE UDP_RX_thread_handle;
extern MainWindow    *w;

char pStreamBuffer[STREAM_ARRAY_SIZE]={0};
//char buffer[UDP_PACKET_SIZE]={0};
WSADATA data;

//DWORD thread_creation_flag;
extern void  (* Callback_Winrad)(int, int, float, short *);
char *pDataBuf = pStreamBuffer;
#ifdef _FILE_OUT_ENABLE_
     char * out_data_file = "out_data.txt";
    FILE *pOutFile;
#endif

  UDP_App  UDPApp;
        void UDP_App::SetDiversityMode(int mode)
        {
            mutex_diversity_flag.lock();
            diversity_flag = mode;
            mutex_diversity_flag.unlock();
        }

        void UDP_App::SetBroadCastFlag(int flag)
        {
            mutex_broadcast.lock();
            udp_broadcast_flag = flag;
            mutex_broadcast.unlock();
        }

        int UDP_App::GetBroadCastFlag()
        {
            int tmp = 0;
            mutex_broadcast.lock();
            tmp = udp_broadcast_flag;
            mutex_broadcast.unlock();
            return tmp;
        }

        int UDP_App::GetDiversityMode()
        {
            int tmp = 0;
            mutex_diversity_flag.lock();
            tmp = diversity_flag;
            mutex_diversity_flag.unlock();
            return tmp;
        }
        void UDP_App::run()
        {
            UDP_Process();
        }


        void UDP_App::SetNetworkFlag(int flag)
        {
            network_start_flag = flag;
        }

        void UDP_App::SetUDPFlag(int flag)
        {
            udp_stop_flag = flag;
        }

        void UDP_App::SetRxChannelNumber(int number)
        {
            mutex_rx_channel.lock();
            rx_channel_number = number;
            mutex_rx_channel.unlock();
        }


        int UDP_App::GetRxChannelNumber()
        {
            int tmp = 0;
            mutex_rx_channel.lock();
            tmp = rx_channel_number;
            mutex_rx_channel.unlock();
            return tmp;
        }

int UDP_Init(unsigned short UDP_Port)//, int diversity_mode, int rx_channel)
{
 int i,ret;
 int results = 0;
 char optval;
 unsigned short Port_Number = APP_PORT;
 struct ip_mreq mreq;
 long mLocalIP = LOCAL_IP_ADDRESS;
#ifdef _FILE_OUT_ENABLE_
 pOutFile = fopen(out_data_file, "w+");
 if(!pOutFile) 
 {
	perror("Cannot open output file\n\r");
	return -1;	
 }
#endif
 // query the system for the local network interface IP address.
/*
 hostent  *pHost = gethostbyname("");   // gets the localhost data.

 if(0 == pHost)
 {
     if(w) w->Show_Network_Message("Cannot read local IP address!\r\n");
#ifdef _FILE_OUT_ENABLE_
     fprintf(pOutFile, "Cannot find local address\n");
#endif
 }
 else if(AF_INET == pHost->h_addrtype)
 {
    // for simplicity, assume that the test systems only have one network
    //    interface, therefore select the first IPv4 address in the list and
    //    store in host byte order.
    mLocalIP = ntohl( * reinterpret_cast<quint32*>( *pHost->h_addr_list ) );
#ifdef _FILE_OUT_ENABLE_
    fprintf(pOutFile, "%lu\n", mLocalIP);
#endif
}
*/
 if (WSAStartup(MAKEWORD(2,2), &data) != 0)
 {
        if(w) w->Show_Network_Message("Cannot Start WSA socket interface!\r\n");
	return(0);
 }
 sock = socket(AF_INET, SOCK_DGRAM, IPPROTO_UDP);
 if (sock == INVALID_SOCKET)
 {
	WSACleanup();
        if(w) w->Show_Network_Message("Cannot open WSA socket!\r\n");
	return(0);
 }
 
 optval=TRUE;
 setsockopt( sock, SOL_SOCKET, SO_REUSEADDR, &optval, sizeof(optval) );
 i=131072;
 setsockopt(sock,SOL_SOCKET,SO_RCVBUF,(char*)&i,sizeof(int));
 i=8192;
 setsockopt(sock,SOL_SOCKET,SO_SNDBUF,(char*)&i,sizeof(int));
 memset(&remote, 0, sizeof(remote)); 
 remote.sin_family = AF_INET;
 remote.sin_addr.s_addr = htonl(INADDR_ANY);//inet_addr("192.168.0.8");
 //remote.sin_addr.s_addr = inet_addr("10.0.0.6");//htonl(0xC0A80001);//INADDR_BROADCAST);//inet_addr("192.168.0.8");
 remote.sin_port = htons(UDP_Port);
 //else remote.sin_port = htons(Port_Number);
 
 ret = bind(sock, (SOCKADDR *)&remote, sizeof(remote));
	if (ret)
	{
                printf("Ku-ku!!! %i\n", ret);
                if(w) w->Show_Network_Message("Cannot Bind WSA socket interface!\r\n");
		WSACleanup();
		return(-1);
	}
        //MULTICAST_ADDRESS
//        if(UDPApp.udp_multicast_flag != 0)
        {
            mLocalIP = INADDR_ANY;/*inet_addr("10.0.0.6");*/
            mreq.imr_interface.s_addr = htonl( mLocalIP );
            mreq.imr_multiaddr.s_addr = htonl( MULTICAST_ADDRESS );
            unsigned int opt = 1; // restricted to 38 hops
            unsigned int ttl = 1; // restricted to 38 hops
            setsockopt(sock, IPPROTO_IP, IP_MULTICAST_LOOP, (const char *)&opt, sizeof(int));
            setsockopt(sock, IPPROTO_IP, IP_MULTICAST_TTL, (const char *)&ttl, sizeof(ttl));
            setsockopt(sock, IPPROTO_IP, IP_MULTICAST_IF, (const char *)&mreq.imr_interface.s_addr, sizeof(mreq.imr_interface.s_addr));
            results = setsockopt(sock, IPPROTO_IP, IP_ADD_MEMBERSHIP, (char*)&mreq, sizeof(mreq));
        }
//	UDP_RX_thread_handle = CreateThread(NULL, 0, UDP_Process, &thread_creation_flag, 0, NULL);
//	if(UDP_RX_thread_handle == NULL)
//            if(w) w->Show_Network_Message("Cannot Start thread!\r\n");
        UDPApp.udp_stop_flag = 0;
        UDPApp.start();
	return 0;
}

int UDP_App::Stream_Data_Copy(char *dest, char *src, int size)
{
    char *src_8bit, *dest_8bit;
    int i;
    if(GetDiversityMode() == 0)
    {
        memcpy(dest,src, size);
    }
    else
    {
        if(GetRxChannelNumber() == AFEDRI_CH1)  src_8bit = src;
        else src_8bit = src + 4;
        dest_8bit = dest;
        for(i=0; i < UDP_PACKET_DATA_SIZE / 8; i++)
        {
            memcpy(dest_8bit,src_8bit, 4);
            dest_8bit += 4;
            src_8bit += 8;
        }
    }
    return 0;
}

//DWORD WINAPI UDP_Process(LPVOID lpParameter)
int UDP_App::UDP_Process()//LPVOID lpParameter)
{
char pTmp[(UDP_PACKET_SIZE + BROADCAST_HEADER_SIZE)*2]={0};
static long rx_packet_idx=0;
static unsigned long tx_packet_idx=0;
unsigned short packet_number=0;
unsigned short old_packet_number=0;
int channel_transfer_size = UDP_PACKET_DATA_SIZE;
int bcast_flag = 0;
int bcast_header_size = BROADCAST_HEADER_SIZE;
#ifdef _FILE_OUT_ENABLE_
	fprintf(pOutFile, "UDP Start!\n");
#endif
        bcast_flag = GetBroadCastFlag();
        if(bcast_flag == 1)
        {
            bcast_header_size = BROADCAST_HEADER_SIZE;
        }
        else
        {
            bcast_header_size = 0;
        }
        while(1)//udp_flag)
	{

                if(GetDiversityMode() == 0) channel_transfer_size = UDP_PACKET_DATA_SIZE;
                else channel_transfer_size = UDP_PACKET_DATA_SIZE/2;
                recvfrom(sock, (char*) pTmp, UDP_PACKET_SIZE + bcast_header_size, 0, 0,0);//&from, &len);
                udp_protocol_id = pTmp[0];
                switch(udp_protocol_id)
                {
                    case UDP_PROTCOL_ID1:
                        bcast_header_size = 0;
                        udp_broadcast_channel = AFEDRI_CH1;
                        break;
                    case UDP_PROTCOL_ID2:
                        bcast_header_size = BROADCAST_HEADER_SIZE;
                        break;
                }

                pDataBuf = &pStreamBuffer[rx_packet_idx];
                if( rx_packet_idx > (STREAM_ARRAY_SIZE - channel_transfer_size))
                {
                    rx_packet_idx = 0;
//                    pDataBuf = &pStreamBuffer[rx_packet_idx];
                }
//                else
//                {
                    pDataBuf = &pStreamBuffer[rx_packet_idx];
                    rx_packet_idx +=  channel_transfer_size;
//                }
                Stream_Data_Copy(pDataBuf,&pTmp[4 + bcast_header_size], channel_transfer_size);
//                memcpy(pDataBuf,&pTmp[4], UDP_PACKET_DATA_SIZE);
                if(network_start_flag == 1)
		{
			while(((rx_packet_idx - tx_packet_idx) & STREAM_ARRAY_MASK ) >= EXTIO_NUMBER_OF_BYTES)
			{
				pDataBuf = &pStreamBuffer[tx_packet_idx];
				tx_packet_idx += EXTIO_NUMBER_OF_BYTES;
                                if(tx_packet_idx >= STREAM_ARRAY_SIZE)
				{
					tx_packet_idx = 0;
                                        //pDataBuf = &pStreamBuffer[0];
				}
				if(Callback_Winrad != NULL) Callback_Winrad(EXTIO_NUMBER_OF_SAMPLES, 0, 0,(short *)pDataBuf);
                        }
                }
		else
		{
			rx_packet_idx=0;
                        tx_packet_idx=0;
                }
//                usleep(100);
//                Sleep(0);
                //error_counter++;
                packet_number = pTmp[2] | (pTmp[3] << 8);
                if(abs(packet_number - old_packet_number) > 1) error_counter++;
                old_packet_number = packet_number;
                packet_counter++;
                if(udp_protocol_id == UDP_PROTCOL_ID2)
                {
                    udp_broadcast_rf_gain = pTmp[4];
                    udp_broadcast_fe_gain = pTmp[5];
                    udp_broadcast_channel = pTmp[6];
                    memcpy((char*)&udp_broadcast_sample_rate, (char*)&pTmp[8], 4);
                    memcpy((char*)&udp_broadcast_freq1, (char*)&pTmp[12], 4);
                    memcpy((char*)&udp_broadcast_freq2, (char*)&pTmp[16], 4);
                }
                if(udp_stop_flag == 1)
                {
                    exit(0);
                    return 1;
                }
//                exec();
	}
	return 0;
}

void UDP_Close()
{
	closesocket(sock);
	WSACleanup();
//	CloseHandle(UDP_RX_thread_handle);
//        UDPApp.quit();// st exit(0);//.terminate();//   quit();
#ifdef _FILE_OUT_ENABLE_
	fclose(pOutFile);
#endif
	return;
}
