//---------------------------------------------------------------------------
#define _ENABLE_QT_APP_
#include <windows.h>
#ifdef _ENABLE_QT_APP_
    #include <QtGui/QApplication>
    #include <QThread>
    #include <QSettings>
    #include "mainwindow.h"
#endif
#include <stdio.h>
//#include "process.h"
//#include "fe_interface.h"
#include "wr_plugin.h"
#include "udp_client.h"

#define EXPORT __stdcall __declspec(dllexport)

extern int RF_Gain_IntDb_2_Int(int gain);
extern QByteArray datagram;
extern QSettings settings;
//---------------------------------------------------------------------------
//#pragma argsused

void (* Callback_Winrad)(int, int, float, short *) = NULL;
extern char pStreamBuffer[];

int argc = 0;
char **argv = 0;
#ifdef _ENABLE_QT_APP_
    QApplication  *a=NULL;
    MainWindow    *w=NULL;
#else
    void *a=NULL;
    void *w=NULL;
#endif

class SDR_app : public QThread
{
     public:
    void run()
    {
        if (!a) a = new QApplication(argc, argv);
        if(!w) w = new MainWindow();
        if(w)
        {
            w->setWindowIcon(QIcon(":/new/prefix1/images/app_icon1.png"));
            w->show();
        }
        if(a) a->exec();
        exec();
        w = NULL;
        a = NULL;
    }
} MyApp;

#ifndef _LINRAD_PLUGIN_
int  /*WINAPI*/  DllEntryPoint(HINSTANCE hinst, unsigned long reason, void* lpReserved)
{
    return 1;
}
#endif
//---------------------------------------------------------------------------
extern "C"
bool EXPORT InitHW(char *name, char *model, int& type)
{
static bool first = true;
type = EXTIO_HW_SOUND_CARD; // 4 ==> data returned via the sound card
if(settings.value("network_enable_flag").toInt() == 1) type = EXTIO_HW_NETWORK;
if(first)
{
    first = false;
    Callback_Winrad = NULL;
}
strcpy(name, "AFEDRI SDR-Net HW"); // change with the name of your HW
strcpy(model, " Mod. v"); // change with the model of your HW
return true;
}
//---------------------------------------------------------------------------
extern "C"
bool EXPORT OpenHW(void)
{
#ifdef _ENABLE_QT_APP_
    MyApp.setPriority(QThread::TimeCriticalPriority);
    MyApp.start();
//    MyApp.wait();
#endif

//    UDP_Init();
     //.... display here the DLL panel ,if any....
    return true;
}
//---------------------------------------------------------------------------
extern "C"
int EXPORT StartHW(long LOfreq)
{
#ifdef _ENABLE_QT_APP_
    if(w)
    {
        w->FE_Set_New_RX_Frequency(LOfreq);
        w->show();
        if(w->network_enable_flag == 1) w->Start_UDP_Stream(true);
    }
#endif
    UDPApp.SetNetworkFlag(1);
//    network_start_flag = 1;
    return EXTIO_NUMBER_OF_SAMPLES; // number of complex elements returned each
}
//---------------------------------------------------------------------------
extern "C"
int EXPORT GetStatus(void)
{
    return 0; // status not supported by this specific HW,
}
//---------------------------------------------------------------------------
extern "C"
void EXPORT StopHW(void)
{
#ifdef _ENABLE_QT_APP_
    if(w)
    {
        w->hide();
        w->Start_UDP_Stream(false);
    }
#endif
    UDPApp.SetNetworkFlag(0);
    //network_start_flag = 0;
    return; // nothing to do with this specific HW
}
//---------------------------------------------------------------------------
extern "C"
void EXPORT CloseHW(void)
{
    //..... here you can shutdown your graphical interface, if any............
#ifdef _ENABLE_QT_APP_
/*        if(w)
        {
            w->hide();
            delete w;
        }
        a->quit();
*/
          MyApp.exit();
          MyApp.wait(200);
//        if(a) delete a;
#endif
     UDPApp.SetUDPFlag(1);
//             udp_flag = 1;
     Sleep(100);
     UDP_Close();
}
//---------------------------------------------------------------------------
extern "C"
int EXPORT SetHWLO(long freq)
{
#ifdef _ENABLE_QT_APP_
    if(w)
    {
        w->FE_Set_New_RX_Frequency(freq);
    }
#endif
//..... set here the LO frequency in the controlled hardware
return 0; // return 0 if the frequency is within the limits the HW can generate
}
//---------------------------------------------------------------------------
extern "C"
long EXPORT GetHWLO(void)
{
    long freq=0;
#ifdef _ENABLE_QT_APP_
    if(w) freq = w->rx_frequency;
#endif
    return freq;
}
//---------------------------------------------------------------------------
extern "C"
long EXPORT GetHWSR(void)
{
    long tmp = 192000;
    if(w) tmp = w->SDR_sample_rate;
//. This DLL controls just an oscillator, not a digitizer
return tmp;//Hz
}
//---------------------------------------------------------------------------
extern "C"
void EXPORT IFLimitsChanged(long low, long high)
{
//Do whatever you want with the information about the new limits of the spectrum/waterfall window
return;
}
//---------------------------------------------------------------------------
extern "C"
void EXPORT TuneChanged(long freq)
{
//. Do whatever you want with the information about the new frequency tuned by the user
    if(w) w->RX_Set_Real_Frequency(freq);
   return;
}
//---------------------------------------------------------------------------
extern "C"
void EXPORT SetCallback(void (* Callback)(int, int, float, short *))
{
    Callback_Winrad = Callback;
//    w->StreamBuffer = pStreamBuffer;
    return; // this HW does not return audio data through the callback device
// nor it has the need to signal a new sampling rate.
}
//---------------------------------------------------------------------------
extern "C"
void EXPORT ShowGUI(void)
{
//. If the DLL has a GUI, now you have to make it visible
return;
}
//---------------------------------------------------------------------------
extern "C"
void EXPORT HideGUI(void)
{
//. If the DLL has a GUI, now you have to hide it
return;
}
//---------------------------------------------------------------------------
/* extern "C"
void EXPORT RawDataReady(long samprate, int *Ldata, int *Rdata, int numsamples)
{
//.. we dont know what to do with the raw audio data just passed from Winrad.
//.. We also could not implement this entry point.
return;
}
*/
//--------------------------------------------------------------------------
//------Linrad Interface function Addition
extern "C"
void EXPORT SetRFGain(int gain)
{
   if(w)  w->Set_RF_Gain(gain);
   return;
}
//------------------------------------------------------------
extern "C"
int EXPORT GetRFGain(void)
{
    int igain=0;
    if(w)
    {
        igain = (int)w->RF_Gain;
    }
//    igain = RF_Gain_IntDb_2_Int(gain);
   return igain;
}

//---------------------------------------------------------------------------
/*******************Extended ExtIO Interface Fuctions ***********************/

extern "C"
void    EXPORT VersionInfo(const char * progname, int ver_major, int ver_minor)
{
//    strcmp(progname, "HDSDR");
//    ver_major = 2;
//    ver_minor = 13;
}
int giAttIdx = 10;
extern "C"
int  EXPORT GetAttenuators(int idx, float * attenuation)
{
    float tmp_gain=0;
    if(idx < 16)
    {
        tmp_gain = 3*idx;
        *attenuation = -10.0F + tmp_gain;
        return 0;
    }
    else
        return 1;

}


extern "C"
int     EXPORT GetActualAttIdx(void)// returns -1 on error
{
    if(w)
    {
        return (w->Get_RF_Gain() >> 3);
    }
    else
    {
        return giAttIdx;
        //        return -1;
    }
}

extern "C"
int     EXPORT SetAttenuator(int idx) // returns != 0 on error
{
    if(idx < 16)
    {
        if(w)
        {
            w->Set_RF_Gain(idx << 3);
            giAttIdx = idx;
            return 0;
        }
        else
        {
            giAttIdx = idx;
            return 0;
        }
    }
    return 1;
}

/**************** End Of Header *********************************************/
